/*******************************************************************************
 * @(#) $Id: SortOrder.java 4277 2009-11-17 12:25:06Z michael_clay $
 * 
 * Copyright (c) 2003, 2008 s IT Solutions AT Spardat GmbH .
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     s IT Solutions AT Spardat GmbH - initial API and implementation
 * 
 * $Created$
 * $Revision: 4277 $
 * Last Change: $Date: 2009-11-17 13:25:06 +0100 (Tue, 17 Nov 2009) $ by $Author: michael_clay $
 *******************************************************************************/
package org.openxma.dsl.platform.dao;


/**
 * Represents the name and direction of an order and is considered to be
 * imposed upon a <i>Query</i> like object.
 * 
 * @version $Revision: 4277 $ $Date: 2009-11-17 13:25:06 +0100 (Tue, 17 Nov 2009) $
 */
public class SortOrder {
    private boolean ascending;
    private String propertyName;

    /**
     * Constructor for Order.
     */
    protected SortOrder(String propertyName, boolean ascending) {
        this.propertyName = propertyName;
        this.ascending = ascending;
    }
    /**
     * @return the ascending
     */
    public boolean isAscending() {
        return ascending;
    }
    /**
     * @return the propertyName
     */
    public String getPropertyName() {
        return propertyName;
    }
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (ascending ? 1231 : 1237);
		result = prime * result + ((propertyName == null) ? 0 : propertyName.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		SortOrder other = (SortOrder) obj;
		if (ascending != other.ascending)
			return false;
		if (propertyName == null) {
			if (other.propertyName != null)
				return false;
		} else if (!propertyName.equals(other.propertyName))
			return false;
		return true;
	}
	@Override
	public String toString() {
		return "Order [ascending=" + ascending + ", propertyName=" + propertyName + "]";
	}
}
