/*
 * @(#) $Id: ValueObjectComparable.java 3862 2009-08-04 13:53:59Z pkofler $
 *
 * Copyright 2004/2005 by SPARDAT Sparkassen-Datendienst Ges.m.b.H.,
 * A-1110 Wien, Geiselbergstr.21-25.
 * All rights reserved.
 *
 */
package org.openxma.dsl.platform.valueobject;

public abstract class ValueObjectComparable<T extends Comparable<T>> extends ValueObject<T> implements Comparable<ValueObjectComparable<T>> {

    private static final long serialVersionUID = 1L;

    public ValueObjectComparable(T value) {
        super(value);
    }

    public int compareTo(ValueObjectComparable<T> pO) {
        if (pO == null) {
            throw new IllegalArgumentException("Object is null, can not compare");
        }
        if (getClass() != pO.getClass()) {
            throw new ClassCastException(pO.getClass().getName());
        }
        // if(!(getObject() instanceof Comparable)) {
        //   throw new IllegalStateException("Sorry, "+this.getClass().getName()+" is not comparable");
        // }
        // if(!(pO.getObject() instanceof Comparable)) {
        //   throw new IllegalStateException("Sorry, "+pO.getClass().getName()+" is not comparable");
        // }
        return getValue().compareTo(pO.getValue());
    }

}
