package org.openxma.dsl.platform.xma.client.mdl;

import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.openxma.dsl.platform.xma.client.browse.BrowseMode;
import org.openxma.dsl.platform.xma.client.browse.BrowseableUIDelegateClient;

import at.spardat.xma.mdl.simple.SimpleUIDelegateClient;
import at.spardat.xma.mdl.simple.SimpleWMClient;
import at.spardat.xma.widgets.DatePicker;

public class SimpleUIDelegateClientDsl extends SimpleUIDelegateClient implements BrowseableUIDelegateClient {

    Control editControl;
    Control browseControl;

    public SimpleUIDelegateClientDsl(SimpleWMClient model) {
        super(model);
    }

    public void attachUI(Object control, Object label) {
        super.attachUI(control, label);
        if (control instanceof Control) {
            if (((Control) control).getParent() instanceof DatePicker) {
                editControl = ((Control)control).getParent();
            } else {
                editControl = (Control)control;
            }
        }
    }

    public void detachUI() {
        super.detachUI();
        editControl = null;
    }

    public void attachBrowseControl(Control control) {
        browseControl = control;
    }

    public void detachBrowseControl() {
        browseControl = null;
    }

    public Control getEditControl() {
        return editControl;
    }

    @Override
    public void setEditable(boolean what) {
        if (isEditable() != what) {
            if (editControl != null && browseControl != null)  {
                editControl.setVisible(what);
                browseControl.setVisible(!what);
                editControl.getParent().layout();
            }
        }
        // TODO: check whether this can be moved into the condition above
        super.setEditable(what);
    }

    protected void UI2Model() {
        super.UI2Model();
        updateBrowseControl();
    }

    protected void setTextOnUI (String text) {
        super.setTextOnUI(text);
        updateBrowseControl();
    }

    protected void updateBrowseControl() {
        if (browseControl == null) {
            return;
        }
        String text = null;
        if (editControl instanceof Text) {
            text =((Text)editControl).getText();
        } else if (editControl instanceof Label) {
            text =((Label)editControl).getText();
        } else if (editControl instanceof DatePicker) {
            text = ((DatePicker)editControl).getDateTextField().getText();
        }
        BrowseMode.updateBrowseControl(browseControl,text);
    }

}
