package org.openxma.dsl.platform.xma.client.table;

public class ColumnInfo {
	
    int index;
    Integer minWidth;
    Integer absoluteWidth;
    Float percent;
    Boolean resizeable;
    String label;
        
    ColumnInfo() {         
    }
    
    public ColumnInfo(int index) {
        this.index = index;
    }           
    
    public ColumnInfo(int index, int absoluteWidth) {
        this.index = index;
        if (absoluteWidth>=0) {
            this.absoluteWidth = absoluteWidth;
        }
    }
    
    public ColumnInfo(int index, int absoluteWidth, float percent) {
        this.index = index;
        if (absoluteWidth != -1 && percent != -1) {
            throw new IllegalArgumentException("One of absoluteWidth or percent must be -1");
        }
        if (absoluteWidth>=0) {        
            this.absoluteWidth = absoluteWidth;
        }
        if (percent>=0) {
            this.percent = percent;
        }
    }   
            
    public ColumnInfo(int index, int absoluteWidth, float percent, String label) {
        this.index = index;
        if (absoluteWidth != -1 && percent != -1) {
            throw new IllegalArgumentException("One of absoluteWidth or percent must be -1");
        }        
        if (absoluteWidth>=0) {        
            this.absoluteWidth = absoluteWidth;
        }
        if (percent>=0) {        
            this.percent = percent;
        }
        this.label = label;
    }       
}